///////////////////////////////////////////////////////////////////////////////
//	p_phys.c
//
//	general physics routines for physics.dll
//
//	Q2FIXME:	replace p_frametime define with actual time of last frame!!
///////////////////////////////////////////////////////////////////////////////

#include	"p_global.h"
#include	"p_user.h"

//	for debugging
#include	"windows.h"

/*


pushmove objects do not obey gravity, and do not interact with each other or trigger fields, but block normal movement and push normal objects when they move.

onground is set for toss objects when they come to a complete rest.  it is set for steping or walking objects 

doors, plats, etc are SOLID_BSP, and MOVETYPE_PUSH
bonus items are SOLID_TRIGGER touch, and MOVETYPE_TOSS
corpses are SOLID_NOT and MOVETYPE_TOSS
crates are SOLID_BBOX and MOVETYPE_TOSS
walking monsters are SOLID_SLIDEBOX and MOVETYPE_STEP
flying/floating monsters are SOLID_SLIDEBOX and MOVETYPE_FLY

solid_edge items only clip against bsp models.

*/

///////////////////////////////////////////////////////////////////////////////
//	defines
///////////////////////////////////////////////////////////////////////////////

#define	PHYS_MAX_CLIP_PLANES	5
#define	PHYS_STOP_EPSILON	0.1

//FIXME: P_AddRotationalFriction:  hacked in for E3 demo
#define	sv_stopspeed		100
#define sv_friction			6
#define sv_waterfriction	1

#define	PHYS_STEPSIZE    18

///////////////////////////////////////////////////////////////////////////////
//	typedefs
///////////////////////////////////////////////////////////////////////////////

typedef struct
{
	edict_t	*ent;
	vec3_t	origin;
	vec3_t	angles;
	float	deltayaw;
} pushed_t;

///////////////////////////////////////////////////////////////////////////////
//	globals
///////////////////////////////////////////////////////////////////////////////

pushed_t	pushed[MAX_EDICTS], *pushed_p;
edict_t		*obstacle;
//	int			c_yes, c_no;	// P_CheckBottom crap

///////////////////////////////////////////////////////////////////////////////
//	P_CheckWaterTransition
//
//	determine if an object has just crossed a water boundary
///////////////////////////////////////////////////////////////////////////////

void	P_CheckWaterTransition (edict_t *ent, vec3_t old_origin)
{
	qboolean	wasinwater, isinwater;

	wasinwater = (ent->watertype & MASK_WATER);
	ent->watertype = gi.pointcontents (ent->s.origin);
	isinwater = ent->watertype & MASK_WATER;

	if (isinwater)
		ent->waterlevel = 1;
	else
		ent->waterlevel = 0;

	if (ent->svflags & SVF_NOSPLASH)
		return;

	if (!wasinwater && isinwater)
		gi.positioned_sound (old_origin, g_edicts, CHAN_AUTO, gi.soundindex("engine/waterhit.wav"), 1, 1, 0);
	else if (wasinwater && !isinwater)
		gi.positioned_sound (ent->s.origin, g_edicts, CHAN_AUTO, gi.soundindex("engine/waterhit.wav"), 1, 1, 0);
}

///////////////////////////////////////////////////////////////////////////////
//	P_CheckGround
///////////////////////////////////////////////////////////////////////////////

void P_CheckGround (edict_t *ent)
{
	vec3_t		point;
	trace_t		trace;

//	if (ent->flags & (FL_SWIM | FL_FLY))
	if (ent->movetype == MOVETYPE_FLY)
		return;

	if (ent->velocity [2] > 100)
	{
//		gi.conprintf ("Entity velocity too high for P_CheckGround.\n");
		ent->groundEntity = NULL;
		return;
	}

	// if the hull point one-quarter unit down is solid the entity is on ground
	point[0] = ent->s.origin[0];
	point[1] = ent->s.origin[1];
	point[2] = ent->s.origin[2] - 0.25;

	if (ent->clipmask)
		trace = gi.trace (ent->s.origin, ent->s.mins, ent->s.maxs, point, ent, ent->clipmask);
	else
		trace = gi.trace (ent->s.origin, ent->s.mins, ent->s.maxs, point, ent, MASK_MONSTERSOLID);

	// check steepness
	if ( trace.plane.normal[2] < 0.7 && !trace.startsolid)
	{
//		gi.conprintf ("P_CheckGround: Plane too steep for groundEntity.\n");
		ent->groundEntity = NULL;
		return;
	}

	//	ent->groundentity = trace.ent;
	//	ent->groundentity_linkcount = trace.ent->linkcount;
	//	if (!trace.startsolid && !trace.allsolid)
	//		VectorCopy (trace.endpos, ent->s.origin);

	if (!trace.startsolid && !trace.allsolid)
	{
		VectorCopy (trace.endpos, ent->s.origin);
		ent->groundEntity = trace.ent;
		ent->groundEntity_linkcount = trace.ent->linkcount;
		ent->velocity[2] = 0;
	}
/*
	else if (ent->velocity [2] == 0)
	{
		ent->groundEntity = g_edicts;
		ent->velocity [2] = 0;
	}
*/
}

///////////////////////////////////////////////////////////////////////////////
//	P_TestEntityPosition
//
///////////////////////////////////////////////////////////////////////////////

edict_t	*P_TestEntityPosition (edict_t *ent)
{
	trace_t	trace;

//	if (ent->clipmask)
//		trace = gi.trace (ent->s.origin, ent->s.mins, ent->s.maxs, ent->s.origin, ent, ent->clipmask);
//	else
		trace = gi.trace (ent->s.origin, ent->s.mins, ent->s.maxs, ent->s.origin, ent, MASK_SOLID);
	
	if (trace.startsolid)
		return g_edicts;
		
	return NULL;
}

///////////////////////////////////////////////////////////////////////////////
//	P_CheckVelocity
//
///////////////////////////////////////////////////////////////////////////////

void P_CheckVelocity (edict_t *ent)
{
	int		i;

//
// bound velocity
//
	for (i=0 ; i<3 ; i++)
	{
		if (ent->velocity[i] > sv_maxvelocity->value)
			ent->velocity[i] = sv_maxvelocity->value;
		else if (ent->velocity[i] < -sv_maxvelocity->value)
			ent->velocity[i] = -sv_maxvelocity->value;
	}
}

///////////////////////////////////////////////////////////////////////////////
//	P_RunThink
//	
//	Runs thinking code for this frame if necessary
///////////////////////////////////////////////////////////////////////////////

qboolean P_RunThink (edict_t *ent)
{
	float	thinktime;

	thinktime = ent->nextthink;
	
	if (thinktime <= 0 || thinktime > level.time + 0.001)
	{
//		if (ent->flags & (FL_MONSTER + FL_CLIENT + FL_BOT))
//			dll_think_stub (ent);
		return true;
	}
	
	if (thinktime < level.time)
		thinktime = level.time;

	ent->nextthink = 0;

//	if (!ent->think)
//		gi.error ("NULL ent->think");

	if (ent->think)
	{
		serverState.time = thinktime;
		ent->think (ent);
	}

	return false;
}

///////////////////////////////////////////////////////////////////////////////
//	SV_Push
//
//	totally inelastic collision
//
//	objects collide and both go off in the same direction,
//	with the same velocity
//
//	since object 1 has to be moving already, we check to
//	see if object 2 is stationary.  If so, we determine 
//	the force necessary to overcome its friction and subtract
//	that from the applied force of the pusher
//
//	pushes entities using velocity vectors
//	different from SV_PushEntity which moves
//	the pushed entity instead of changing its
//	velocity
//
///////////////////////////////////////////////////////////////////////////////

void	SV_Push (edict_t *e1, edict_t *e2)
{
	vec3_t	new_dir, up, end;
	float	p1, p2, vf, dp2;
	trace_t	trace;

	// find the momentum of each object
	p1 = VectorLength (e1->velocity) * e1->mass;
	p2 = VectorLength (e2->velocity) * e2->mass;

	//	if the impacted object is not moving, find the force
	//	needed to overcome it's friction
	if (VectorLength (e2->velocity) == 0.0)
	{
		// FIXME: once we have texture detection, base friction
		// coeffecient on the current surface
		// assume friction of approximately steel on steel
		dp2 = 800 * e2->mass * 0.3;
		p1 = p1 - dp2;
	}
	// otherwise, give it some minor friction
	else
	{
		dp2 = 800 * e2->mass * 0.1;
		p1 = p1 - dp2;
	}

	if (p1 < 0) p1 = 0;

	//	add the two velocities to get the resulting direction
	VectorAdd (e1->velocity, e2->velocity, new_dir);
	VectorNormalize (new_dir);

	vf = (p1 + p2) / (e1->mass + e2->mass);
	
	// scale the resultant vector by the final velocity
	VectorScale (new_dir, vf, e2->velocity);
	
	// remove onground flags
	if (e1->movetype != MOVETYPE_WALK)
		//	e1->flags -= (e1->flags & FL_ONGROUND);
		e1->groundEntity = NULL;
	if (e2->movetype != MOVETYPE_WALK && e2->flags & FL_ONGROUND)
	{
		//	e2->flags -= FL_ONGROUND;
		e2->groundEntity = NULL;

		up [0] = up [1] = 0;
		up [2] = 1.0;

		VectorAdd (up, e2->s.origin, end);
		if (e2->clipmask)
	        trace = gi.trace (e2->s.origin, e2->s.mins, e2->s.maxs, end, e2, e2->clipmask);
		else
			trace = gi.trace (e2->s.origin, e2->s.mins, e2->s.maxs, end, e2, MASK_MONSTERSOLID);

	    VectorCopy (trace.endpos, e2->s.origin);
	    gi.linkentity (e2);
	}
}

///////////////////////////////////////////////////////////////////////////////
//	P_Impact
//	
//	Two entities have touched, so run their toucmap h functions
///////////////////////////////////////////////////////////////////////////////

void P_Impact (edict_t *e1, trace_t *trace)
{
	edict_t		*e2;
//	cplane_t	backplane;

	e2 = trace->ent;

	///	Nelno:	if one entity is a client, then impart his velocity to
	///	the other object
/*
	if ((e1->solid != SOLID_NOT) && (e2->solid != SOLID_NOT))
	{
		if ((e1->flags & FL_PUSHABLE) || (e2->flags & FL_PUSHABLE))
		{
			if ((e1->movetype == MOVETYPE_WALK || e1->movetype == MOVETYPE_TOSS 
				|| e1->movetype == MOVETYPE_BOUNCE || e1->movetype == MOVETYPE_STEP || e1->movetype == MOVETYPE_FLY) &&
				(e2->movetype == MOVETYPE_WALK || e2->movetype == MOVETYPE_TOSS 
				|| e2->movetype == MOVETYPE_BOUNCE || e2->movetype == MOVETYPE_STEP || e2->movetype == MOVETYPE_FLY))
			SV_Push (e1, e2);
		}
	}
*/

	if (e1->touch && e1->solid != SOLID_NOT)
		e1->touch (e1, e2, &trace->plane, trace->surface);
	
	if (e2->touch && e2->solid != SOLID_NOT)
		e2->touch (e2, e1, &trace->plane, trace->surface);    // mike: this should send trace info, right??
//		e2->touch (e2, e1, NULL, NULL);
}


///////////////////////////////////////////////////////////////////////////////
//	ClipVelocity
//
//	Slide off of the impacting object
//	returns the blocked flags (1 = floor, 2 = step / wall)
///////////////////////////////////////////////////////////////////////////////

int ClipVelocity (vec3_t in, vec3_t normal, vec3_t out, float overbounce)
{
	float	backoff;
	float	change;
	int		i, blocked;
	
	blocked = 0;
	if (normal [2] > 0)
		blocked |= 1;		// floor
	if (!normal [2])
		blocked |= 2;		// step
	
	backoff = DotProduct (in, normal) * overbounce;

	for (i=0 ; i<3 ; i++)
	{
		change = normal [i] * backoff;
		out[i] = in[i] - change;
		if (out [i] > -PHYS_STOP_EPSILON && out [i] < PHYS_STOP_EPSILON)
			out [i] = 0;
	}
	
	return blocked;
}


///////////////////////////////////////////////////////////////////////////////
//	P_FlyMove
//
//	The basic solid body movement clip that slides along multiple planes
//	Returns the clipflags if the velocity was modified (hit something solid)
//	1 = floor
//	2 = wall / step
//	4 = dead stop
///////////////////////////////////////////////////////////////////////////////

int P_FlyMove (edict_t *ent, float time, int mask)
{
	edict_t		*hit;
	int			bumpcount, numbumps;
	vec3_t		dir;
	float		d;
	int			numplanes;
	vec3_t		planes[PHYS_MAX_CLIP_PLANES];
	vec3_t		primal_velocity, original_velocity, new_velocity;
	int			i, j;
	trace_t		trace;
	vec3_t		end;
	float		time_left;
	int			blocked;
	
	numbumps = 4;
	
	blocked = 0;
	VectorCopy (ent->velocity, original_velocity);
	VectorCopy (ent->velocity, primal_velocity);
	numplanes = 0;
	
	time_left = time;

	ent->groundEntity = NULL;
	for (bumpcount=0 ; bumpcount<numbumps ; bumpcount++)
	{
		for (i=0 ; i<3 ; i++)
			end[i] = ent->s.origin[i] + time_left * ent->velocity[i];

		trace = gi.trace (ent->s.origin, ent->s.mins, ent->s.maxs, end, ent, mask);

		if (trace.allsolid)
		{	// entity is trapped in another solid
			VectorCopy (vec3_origin, ent->velocity);
			return 3;
		}

		if (trace.fraction > 0)
		{	// actually covered some distance
			VectorCopy (trace.endpos, ent->s.origin);
			VectorCopy (ent->velocity, original_velocity);
			numplanes = 0;
		}

		if (trace.fraction == 1)
			 break;		// moved the entire distance

		hit = trace.ent;

		if (trace.plane.normal[2] > 0.7)
		{
			blocked |= 1;		// floor
			if ( hit->solid == SOLID_BSP)// || hit == g_edicts)
			{
				ent->groundEntity = hit;
				ent->groundEntity_linkcount = hit->linkcount;
			}
		}

		//	NelnoFIXME:	should we check for step sides that aren't straight up/down?
		if (!trace.plane.normal[2])
		{
			blocked |= 2;		// step
		}

//
// run the impact function
//
		P_Impact (ent, &trace);
		if (!ent->inuse)
			break;		// removed by the impact function

		
		time_left -= time_left * trace.fraction;
		
	// cliped to another plane
		if (numplanes >= PHYS_MAX_CLIP_PLANES)
		{	// this shouldn't really happen
			VectorCopy (vec3_origin, ent->velocity);
			return 3;
		}

		VectorCopy (trace.plane.normal, planes[numplanes]);
		numplanes++;

//
// modify original_velocity so it parallels all of the clip planes
//
		for (i=0 ; i<numplanes ; i++)
		{
			ClipVelocity (original_velocity, planes[i], new_velocity, 1);
			for (j=0 ; j<numplanes ; j++)
				if (j != i)
				{
					if (DotProduct (new_velocity, planes[j]) < 0)
						break;	// not ok
				}
			if (j == numplanes)
				break;
		}
		
		if (i != numplanes)
		{	// go along this plane
			VectorCopy (new_velocity, ent->velocity);
		}
		else
		{	// go along the crease
			if (numplanes != 2)
			{
//				gi.dprintf ("clip velocity, numplanes == %i\n",numplanes);
				VectorCopy (vec3_origin, ent->velocity);
				return 7;
			}
			CrossProduct (planes[0], planes[1], dir);
			d = DotProduct (dir, ent->velocity);
			VectorScale (dir, d, ent->velocity);
		}

//
// if original velocity is against the original velocity, stop dead
// to avoid tiny occilations in sloping corners
//
		if (DotProduct (ent->velocity, primal_velocity) <= 0)
		{
			VectorCopy (vec3_origin, ent->velocity);
			return blocked;
		}
	}

	return blocked;
}


///////////////////////////////////////////////////////////////////////////////
//	P_AddGravity
//
///////////////////////////////////////////////////////////////////////////////

void P_AddGravity (edict_t *ent)
{
	ent->velocity[2] -= ent->gravity * sv_gravity->value * ent->gravity * p_frametime;
//	ent->velocity[2] -= ent->gravity * 1 * p_frametime;
}

/* ------------------------------- PUSHMOVE -------------------------------- */


///////////////////////////////////////////////////////////////////////////////
//	P_PushEntity
//
//	Does not change the entities velocity at all
///////////////////////////////////////////////////////////////////////////////

trace_t P_PushEntity (edict_t *ent, vec3_t push)
{
	trace_t	trace;
	vec3_t	start;
	vec3_t	end;
	int		mask;

	VectorCopy (ent->s.origin, start);
	VectorAdd (start, push, end);

retry:
	if (ent->clipmask)
		mask = ent->clipmask;
	else
		mask = MASK_SOLID;

	trace = gi.trace (start, ent->s.mins, ent->s.maxs, end, ent, mask);

	if (trace.allsolid || trace.startsolid)
	{
		//	entity is stuck inside another entity
		//	GET IT OUT!! IT HURTS!! IT HURTS!!
//		gi.dprintf ("%s is stuck in %s.\n", ent->className, trace.ent->className);
//		trace.fraction = 0.0;
//		VectorCopy (start, trace.endpos);
	}
	
	VectorCopy (trace.endpos, ent->s.origin);
	gi.linkentity (ent);

	if (trace.fraction != 1.0)
	{
		P_Impact (ent, &trace);

		//	if the pushed entity went away and the pusher is still there
		if (!trace.ent->inuse && ent->inuse)
		{
			// move the pusher back and try again
			VectorCopy (start, ent->s.origin);
			gi.linkentity (ent);
			goto retry;
		}
	}

	if (ent->inuse) 
		P_TouchTriggers (ent);

	return trace;
}					

///////////////////////////////////////////////////////////////////////////////
//	P_Push
//
//	Objects need to be moved back on a failed push,
//	otherwise riders would continue to slide.
///////////////////////////////////////////////////////////////////////////////

int	P_Push (edict_t *pusher, vec3_t move, vec3_t amove)
{
	int			i, e;
	edict_t		*check, *block;
	vec3_t		mins, maxs;
	pushed_t	*p;
	vec3_t		org, org2, move2, forward, right, up;

	// clamp the move to 1/8 units, so the position will
	// be accurate for client side prediction
	for (i=0 ; i<3 ; i++)
	{
		float	temp;
		temp = move[i]*8.0;
		if (temp > 0.0)
			temp += 0.5;
		else
			temp -= 0.5;
		move[i] = 0.125 * (int)temp;
	}

	// find the bounding box
	for (i=0 ; i<3 ; i++)
	{
		mins[i] = pusher->absmin[i] + move[i];
		maxs[i] = pusher->absmax[i] + move[i];
	}

// we need this for pushing things later
	VectorSubtract (vec3_origin, amove, org);
	AngleVectors (org, forward, right, up);

// save the pusher's original position
	pushed_p->ent = pusher;
	VectorCopy (pusher->s.origin, pushed_p->origin);
	VectorCopy (pusher->s.angles, pushed_p->angles);
	if (pusher->client)
		pushed_p->deltayaw = pusher->client->ps.pmove.delta_angles[YAW];
	pushed_p++;

// move the pusher to it's final position
	VectorAdd (pusher->s.origin, move, pusher->s.origin);
	VectorAdd (pusher->s.angles, amove, pusher->s.angles);
	gi.linkentity (pusher);

	// see if any solid entities are inside the final position
	check = g_edicts+1;
	for (e = 1; e < globals.num_edicts; e++, check++)
	{
		if (!check->inuse)
			continue;
		if (check->movetype == MOVETYPE_PUSH
		|| check->movetype == MOVETYPE_STOP
		|| check->movetype == MOVETYPE_NONE
		|| check->movetype == MOVETYPE_NOCLIP)
			continue;

//		if (!check->area.prev)
//			continue;

	// if the entity is standing on the pusher, it will definitely be moved
		if (check->groundEntity != pusher)
		{
			// see if the ent needs to be tested
			if ( check->absmin[0] >= maxs[0]
			|| check->absmin[1] >= maxs[1]
			|| check->absmin[2] >= maxs[2]
			|| check->absmax[0] <= mins[0]
			|| check->absmax[1] <= mins[1]
			|| check->absmax[2] <= mins[2] )
				continue;

			// see if the ent's bbox is inside the pusher's final position
			if (!P_TestEntityPosition (check))
				continue;
		}

		if ((pusher->movetype == MOVETYPE_PUSH) || (check->groundEntity == pusher))
		{
			// move this entity
			pushed_p->ent = check;
			VectorCopy (check->s.origin, pushed_p->origin);
			VectorCopy (check->s.angles, pushed_p->angles);
			pushed_p++;

			// try moving the contacted entity 
			VectorAdd (check->s.origin, move, check->s.origin);
			if (check->client)
			{	// FIXME: doesn't rotate monsters?
				check->client->ps.pmove.delta_angles[YAW] += amove[YAW];
			}

			// figure movement due to the pusher's amove
			VectorSubtract (check->s.origin, pusher->s.origin, org);
			org2[0] = DotProduct (org, forward);
			org2[1] = -DotProduct (org, right);
			org2[2] = DotProduct (org, up);
			VectorSubtract (org2, org, move2);
			VectorAdd (check->s.origin, move2, check->s.origin);

			// may have pushed them off an edge
			if (check->groundEntity != pusher)
				check->groundEntity = NULL;

			block = P_TestEntityPosition (check);
			if (!block)
			{	// pushed ok
				gi.linkentity (check);
				// impact?
				continue;
			}

			// if it is ok to leave in the old position, do it
			// this is only relevent for riding entities, not pushed
			// FIXME: this doesn't acount for rotation
			VectorSubtract (check->s.origin, move, check->s.origin);
			block = P_TestEntityPosition (check);
			if (!block)
			{
				pushed_p--;
				continue;
			}
		}
		
		// save off the obstacle so we can call the block function
		obstacle = check;

		// move back any entities we already moved
		// go backwards, so if the same entity was pushed
		// twice, it goes back to the original position
		for (p=pushed_p-1 ; p>=pushed ; p--)
		{
			VectorCopy (p->origin, p->ent->s.origin);
			VectorCopy (p->angles, p->ent->s.angles);
			if (p->ent->client)
			{
				p->ent->client->ps.pmove.delta_angles[YAW] = p->deltayaw;
			}
			gi.linkentity (p->ent);
		}
		return false;
	}

//FIXME: is there a better way to handle this?
	// see if anything we moved has touched a trigger
	for (p=pushed_p-1 ; p>=pushed ; p--)
		P_TouchTriggers (p->ent);

	return true;
}

///////////////////////////////////////////////////////////////////////////////
//	P_Physics_Pusher
//
//	Bmodel objects don't interact with each other, but
//	push all box objects
///////////////////////////////////////////////////////////////////////////////

void P_Physics_Pusher (edict_t *ent)
{
	vec3_t		move, amove;
	edict_t		*part, *mv;

	// if not a team captain, so movement will be handled elsewhere

	//	Q2FIXME:	Q2 teamplay crap.  Needed???
	if ( ent->flags & FL_TEAMSLAVE)
		return;

	// make sure all team slaves can move before commiting
	// any moves or calling any think functions
	// if the move is blocked, all moved objects will be backed out
//retry:
	pushed_p = pushed;
	for (part = ent ; part ; part=part->teamchain)
	{
		if (part->velocity[0] || part->velocity[1] || part->velocity[2] ||
			part->avelocity[0] || part->avelocity[1] || part->avelocity[2]
			)
		{	// object is moving
			VectorScale (part->velocity, p_frametime, move);
			VectorScale (part->avelocity, p_frametime, amove);

			if (!P_Push (part, move, amove))
				break;	// move was blocked
		}
	}
	if (pushed_p > &pushed[MAX_EDICTS])
		gi.error ("pushed_p > &pushed[MAX_EDICTS], memory corrupted");

	if (part)
	{
		// the move failed, bump all nextthink times and back out moves
		for (mv = ent ; mv ; mv=mv->teamchain)
		{
			if (mv->nextthink > 0)
				mv->nextthink += p_frametime;
		}

		// if the pusher has a "blocked" function, call it
		// otherwise, just stay in place until the obstacle is gone
		if (part->blocked)
			part->blocked (part, obstacle);
#if 0
		// if the pushed entity went away and the pusher is still there
		if (!obstacle->inuse && part->inuse)
			goto retry;
#endif
	}
	else
	{
		// the move succeeded, so call all think functions
		for (part = ent ; part ; part=part->teamchain)
		{
			P_RunThink (part);
		}
	}
}

/* -------------------------- MOVETYPE_NONE -------------------------------- */


///////////////////////////////////////////////////////////////////////////////
//  P_Physics_None
//
//	Non moving objects can only think
///////////////////////////////////////////////////////////////////////////////

void P_Physics_None (edict_t *ent)
{
	P_RunThink (ent);
}

/* -------------------------- MOVETYPE_NOCLIP ------------------------------ */

///////////////////////////////////////////////////////////////////////////////
//	P_Physics_Noclip
//
//	A moving object that doesn't obey physics
///////////////////////////////////////////////////////////////////////////////

void P_Physics_Noclip (edict_t *ent)
{
	if (!P_RunThink (ent))
		return;
	
	VectorMA (ent->s.angles, p_frametime, ent->avelocity, ent->s.angles);
	VectorMA (ent->s.origin, p_frametime, ent->velocity, ent->s.origin);

	gi.linkentity (ent);
}


/* ------------------ MOVETYPE_TOSS, MOVETYPE_BOUNCE ---------------------- */


///////////////////////////////////////////////////////////////////////////////
//	P_Physics_Toss
//
//	Toss, bounce, and fly movement.  When onground, do nothing.
///////////////////////////////////////////////////////////////////////////////

void P_Physics_Toss (edict_t *ent)
{
	trace_t		trace;
	vec3_t		move;
	float		backoff;
	edict_t		*slave;
	vec3_t		old_origin;
/*
	if (ent->className)
		if (!stricmp (ent->className, "monster_battleboar"))
			DebugBreak ();
*/
	// regular thinking
	P_RunThink (ent);

	// if not a team captain, so movement will be handled elsewhere
	if ( ent->flags & FL_TEAMSLAVE)
		return;

	if (ent->velocity [2] > 0)
		ent->groundEntity = NULL;
/*
	else if (ent->velocity [2] == 0)
		P_CheckGround (ent);
*/
// check for the groundEntity going away
	if (ent->groundEntity)
		if (!ent->groundEntity->inuse)
			ent->groundEntity = NULL;

// if onground, return without moving
	if ( ent->groundEntity )
		return;

	VectorCopy (ent->s.origin, old_origin);

	P_CheckVelocity (ent);

// add gravity
	if ((ent->flags & FL_SWIM) && ent->movetype == MOVETYPE_FLY && ent->waterlevel < 3)
		P_AddGravity (ent);		

	if (ent->movetype != MOVETYPE_FLY && ent->movetype != MOVETYPE_FLYMISSILE && 
		ent->movetype != MOVETYPE_BOUNCEMISSILE)
		P_AddGravity (ent);

// move angles
	VectorMA (ent->s.angles, p_frametime, ent->avelocity, ent->s.angles);

// move origin
	VectorScale (ent->velocity, p_frametime, move);
	trace = P_PushEntity (ent, move);

	if (!ent->inuse)
		return;

	if (trace.fraction < 1)
	{
		if (ent->movetype == MOVETYPE_BOUNCE || ent->movetype == MOVETYPE_BOUNCEMISSILE)
			backoff = 1.5;
		else
			backoff = 1;

      if (ent->elasticity)
         backoff = ent->elasticity;

		ClipVelocity (ent->velocity, trace.plane.normal, ent->velocity, backoff);

	// stop if on ground
		if (trace.plane.normal[2] > 0.7)
		{	
//			if ((ent->movetype != MOVETYPE_BOUNCE && ent->movetype != MOVETYPE_BOUNCEMISSILE) ||
//				(VectorLength (ent->velocity) < 250.0 && ent->velocity [2] < 60))
			if (ent->velocity[2] < 60 || ent->movetype != MOVETYPE_BOUNCE )
			{
				ent->groundEntity = trace.ent;
				ent->groundEntity_linkcount = trace.ent->linkcount;
				VectorCopy (vec3_origin, ent->velocity);
				VectorCopy (vec3_origin, ent->avelocity);
			}
		}

//		if (ent->touch)
//			ent->touch (ent, trace.ent, &trace.plane, trace.surface);
	}
	
	P_CheckWaterTransition (ent, old_origin);

// move teamslaves
	for (slave = ent->teamchain; slave; slave = slave->teamchain)
	{
		VectorCopy (ent->s.origin, slave->s.origin);
		gi.linkentity (slave);
	}
}

/* ---------------------------- MOVETYPE_STEP ------------------------------ */

///////////////////////////////////////////////////////////////////////////////
//	P_CheckBottom
//
//	Returns false if any part of the bottom of the entity is off an edge that
//	is not a staircase.
///////////////////////////////////////////////////////////////////////////////

qboolean P_CheckBottom (edict_t *ent)
{
	//	Nelno:	whatever...
/*
	vec3_t	mins, maxs, start, stop;
	trace_t	trace;
	int		x, y;
	float	mid, bottom;
	
	VectorAdd (ent->s.origin, ent->mins, mins);
	VectorAdd (ent->s.origin, ent->maxs, maxs);

// if all of the points under the corners are solid world, don't bother
// with the tougher checks
// the corners must be within 16 of the midpoint
	start[2] = mins[2] - 1;
	for	(x=0 ; x<=1 ; x++)
		for	(y=0 ; y<=1 ; y++)
		{
			start[0] = x ? maxs[0] : mins[0];
			start[1] = y ? maxs[1] : mins[1];
			if (gi.pointcontents (start) != CONTENTS_SOLID)
				goto realcheck;
		}

	c_yes++;
	return true;		// we got out easy

realcheck:
	c_no++;
//
// check it for real...
//
	start[2] = mins[2];
	
// the midpoint must be within 16 of the bottom
	start[0] = stop[0] = (mins[0] + maxs[0])*0.5;
	start[1] = stop[1] = (mins[1] + maxs[1])*0.5;
	stop[2] = start[2] - 2*STEPSIZE;
	trace = gi.trace (start, vec3_origin, vec3_origin, stop, ent, MASK_MONSTERSOLID);

	if (trace.fraction == 1.0)
		return false;
	mid = bottom = trace.endpos[2];
	
// the corners must be within 16 of the midpoint	
	for	(x=0 ; x<=1 ; x++)
		for	(y=0 ; y<=1 ; y++)
		{
			start[0] = stop[0] = x ? maxs[0] : mins[0];
			start[1] = stop[1] = y ? maxs[1] : mins[1];
			
			trace = gi.trace (start, vec3_origin, vec3_origin, stop, ent, MASK_MONSTERSOLID);
			
			if (trace.fraction != 1.0 && trace.endpos[2] > bottom)
				bottom = trace.endpos[2];
			if (trace.fraction == 1.0 || mid - trace.endpos[2] > STEPSIZE)
				return false;
		}

	c_yes++;
	return true;
*/
	vec3_t	start, stop;
	trace_t	trace;

	start [0] = stop [0] = ent->s.origin [0];
	start [1] = stop [1] = ent->s.origin [1];
	start [2] = stop [2] = ent->s.origin [2];
	stop [2] += 1;

	trace = gi.trace (start, ent->s.mins, ent->s.maxs, stop, ent, MASK_MONSTERSOLID);

	if (trace.fraction == 1.0)
		//	not on ground
		return	false;
	else
		return	true;
}

///////////////////////////////////////////////////////////////////////////////
//	P_AddRotationalFricton
//
///////////////////////////////////////////////////////////////////////////////

void P_AddRotationalFriction (edict_t *ent)
{
	int		n;
	float	adjustment;

	VectorMA (ent->s.angles, p_frametime, ent->avelocity, ent->s.angles);
	adjustment = p_frametime * sv_stopspeed * sv_friction;
	for (n = 0; n < 3; n++)
	{
		if (ent->avelocity[n] > 0)
		{
			ent->avelocity[n] -= adjustment;
			if (ent->avelocity[n] < 0)
				ent->avelocity[n] = 0;
		}
		else
		{
			ent->avelocity[n] += adjustment;
			if (ent->avelocity[n] > 0)
				ent->avelocity[n] = 0;
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
//	P_Physics_Step
//
//Monsters freefall when they don't have a ground entity, otherwise
//all movement is done with discrete steps.
//
//This is also used for objects that have become still on the ground, but
//will fall if the floor is pulled out from under them.
//FIXME: is this true?
///////////////////////////////////////////////////////////////////////////////

void P_Physics_Step (edict_t *ent)
{
	qboolean	wasonground;
	qboolean	hitsound = false;
	float		*vel;
	float		speed, newspeed, control;
	float		friction;
	edict_t		*groundEntity;
	int			mask;

	// airborn monsters should always check for ground
	//	Nelno: removed temporarily
	if (!ent->groundEntity)
		P_CheckGround (ent);

	groundEntity = ent->groundEntity;

	P_CheckVelocity (ent);

	if (groundEntity)
		wasonground = true;
	else
		wasonground = false;
		
	if (ent->avelocity[0] || ent->avelocity[1] || ent->avelocity[2])
		P_AddRotationalFriction (ent);

	// add gravity except:
	//   flying monsters
	//   swimming monsters who are in the water
	if (! wasonground)
		if (ent->movetype == MOVETYPE_FLY && (ent->flags & FL_SWIM))
			if (!((ent->flags & FL_SWIM) && (ent->waterlevel > 2)))
			{
				if (ent->velocity[2] < sv_gravity->value*-0.1)
					hitsound = true;
				if (ent->waterlevel == 0)
					P_AddGravity (ent);
			}

	//	Nelno:	why is this in here twice?
	//	friction for flying monsters that have been given vertical velocity
	if ((ent->movetype == MOVETYPE_FLY) && !(ent->flags & FL_SWIM) && (ent->velocity[2] != 0))
	{
		speed = fabs(ent->velocity[2]);
		control = speed < sv_stopspeed ? sv_stopspeed : speed;
		friction = sv_friction/3;
		newspeed = speed - (p_frametime * control * friction);
		if (newspeed < 0)
			newspeed = 0;
		newspeed /= speed;
		ent->velocity[2] *= newspeed;
	}

	//	friction for swimming monsters that have been given vertical velocity
	if ((ent->flags & FL_SWIM) && (ent->velocity[2] != 0))
	{
		speed = fabs(ent->velocity[2]);
		control = speed < sv_stopspeed ? sv_stopspeed : speed;
		newspeed = speed - (p_frametime * control * sv_waterfriction * ent->waterlevel);
		if (newspeed < 0)
			newspeed = 0;
		newspeed /= speed;
		ent->velocity[2] *= newspeed;
	}

	if (ent->velocity[2] || ent->velocity[1] || ent->velocity[0])
	{
		// apply friction
		// let dead monsters who aren't completely onground slide
		if ((wasonground) || (ent->movetype == MOVETYPE_FLY))
			if (!(ent->health <= 0.0 && !P_CheckBottom (ent)))
			{
				vel = ent->velocity;
				speed = sqrt(vel[0]*vel[0] +vel[1]*vel[1]);
				if (speed)
				{
					friction = sv_friction;

					control = speed < sv_stopspeed ? sv_stopspeed : speed;
					newspeed = speed - p_frametime*control*friction;

					if (newspeed < 0)
						newspeed = 0;
					newspeed /= speed;

					vel[0] *= newspeed;
					vel[1] *= newspeed;
				}
			}

		if (ent->svflags & SVF_MONSTER)
			mask = MASK_MONSTERSOLID;
		else
			mask = MASK_SOLID;
		P_FlyMove (ent, p_frametime, mask);

		gi.linkentity (ent);
		P_TouchTriggers (ent);

		if (ent->groundEntity)
			if (!wasonground)
				if (hitsound)
					gi.sound (ent, 0, gi.soundindex("world/land.wav"), 1, 1, 0);
	}

// regular thinking
	P_RunThink (ent);
}

/* --------------------------- MOVETYPE_WALK ------------------------------- */

///////////////////////////////////////////////////////////////////////////////
//	P_BotFriction
//
//	Nelno's routine to stop bots from
//	sliding all over the damn place
//	
//	FIXME:	make so only bots with a flag set can walk off of ledges
//	Q2FIXME:make sv_friction, sv_stopspeed and cvars!
///////////////////////////////////////////////////////////////////////////////

void P_BotFriction (edict_t *ent)
{
	vec3_t	vel, origin;
	float	speed, newspeed, control;
	vec3_t	start, stop;
	float	friction;
	trace_t	trace;

	// if bot is in the air, don't apply friction!!!
//	if (!(ent->flags & FL_ONGROUND))
	if (!ent->groundEntity)
		return;

	//	set up vars to take the place of SV_USER globals
	VectorCopy (ent->velocity, vel);
	VectorCopy (ent->s.origin, origin);
	
	//	get the speed in the xy plane
	speed = sqrt (vel [0] * vel [0] + vel [1] * vel [1]);
	
	if (!speed)
		return;

	//	if the leading edge is over a dropoff, increase friction
	//	start exactly at the bottom of ent's bounding box
	start [0] = stop [0] = origin [0];
	start [1] = stop [1] = origin [1];
	start [2] = origin[2];
	
	//	end 34 units below (stair height + 10, or jump height + 2)
	stop [2] = start [2] + ent->s.mins [2];

	trace = gi.trace (start, ent->s.mins, ent->s.maxs, stop, ent, CHOOSE_CLIP(ent));

	//	no friction if going up/down a slope
	if (trace.fraction < 1.0 && trace.plane.normal [2] < 1.0 && speed != 0)
			return;

	friction = sv_friction * 2.0;

	// apply friction	
	control = speed < sv_stopspeed ? sv_stopspeed : speed;
	newspeed = speed - p_frametime * control * friction;
	
	if (newspeed < 0)
		newspeed = 0;
	
	newspeed /= speed;

	ent->velocity [0] = vel [0] * newspeed;
	ent->velocity [1] = vel [1] * newspeed;
	ent->velocity [2] = vel [2] * newspeed;
}

///////////////////////////////////////////////////////////////////////////////
//	P_BotWalkMove
//
//	Only used by players
///////////////////////////////////////////////////////////////////////////////

void P_BotWalkMove (edict_t *ent)
{
    vec3_t			upmove, downmove;
    vec3_t			oldorg, oldvel;
    vec3_t			nosteporg, nostepvel;
    int				clip, mask;
    edict_t			*oldonground;
    trace_t			downtrace;

	//
	// do a regular slide move unless it looks like you ran into a step
	//
	if (!ent->groundEntity)
		P_CheckGround (ent);

	//	save groundEntity and then clear it for move
	oldonground = ent->groundEntity;
    
    VectorCopy (ent->s.origin, oldorg);
    VectorCopy (ent->velocity, oldvel);
    
	//	Q2FIXME:	use ent->clipmask, set it up in ai init routines 
	mask = CHOOSE_CLIP(ent);
    clip = P_FlyMove (ent, p_frametime, mask);

    if (!(clip & 2))
		return;        // move didn't block on a step

	//	Q2FIXME:	this should work...
//    if (!oldonground && ent->waterlevel == 0)
//        return;        // don't stair up while jumping

    if (ent->flags & FL_WATERJUMP)
		//	jumping out of water
        return;

    VectorCopy (ent->s.origin, nosteporg);
    VectorCopy (ent->velocity, nostepvel);

//
// try moving up and forward to go up a step
//
	VectorCopy (oldorg, ent->s.origin);    // back to start pos

    VectorCopy (vec3_origin, upmove);
    VectorCopy (vec3_origin, downmove);
    
	upmove [2] = PHYS_STEPSIZE;
    downmove [2] = - PHYS_STEPSIZE + oldvel [2] * p_frametime;

	// move up
    P_PushEntity (ent, upmove);

	// move forward
    ent->velocity[0] = oldvel[0];
    ent->velocity[1] = oldvel[1];
    ent->velocity[2] = 0;
    
	clip = P_FlyMove (ent, p_frametime, mask);

	//	check for stuckness, possibly due to the limited precision of floats
	//	in the clipping hulls

	//	Q2FIXME:	still needed with Q2's clipping?
/*
    if (clip)
    {
        if (fabs(oldorg[1] - ent->v.origin[1]) < 0.03125
        && fabs(oldorg[0] - ent->v.origin[0]) < 0.03125 )
        {    // stepping up didn't make any progress
            clip = SV_TryUnstick (ent, oldvel);
        }
    }
*/    
	// move down
    downtrace = P_PushEntity (ent, downmove);

    if (downtrace.plane.normal [2] > 0.7)
    {
        if (ent->solid == SOLID_BSP || ent->solid == SOLID_BBOX)
        {
            //	Q2FIXME: still need FL_ONGROUND???
			ent->flags = ent->flags | FL_ONGROUND;
            ent->groundEntity = downtrace.ent;
        }
    }
    else
    {
		//	if the push down didn't end up on good ground, use the move without
		//	the step up.  This happens near wall / slope combinations, and can
		//	cause the player to hop up higher on a slope too steep to climb    
        VectorCopy (nosteporg, ent->s.origin);
        VectorCopy (nostepvel, ent->velocity);
    }
}


///////////////////////////////////////////////////////////////////////////////
//	Physics_Walk
//
//	physics for MOVETYPE_WALK
///////////////////////////////////////////////////////////////////////////////

void	Physics_Walk (edict_t *ent)
{
	vec3_t	old_origin;

	//	Q2FIXME:	necessary?
/*
	if (!P_CheckWater (ent) && ! ((int)ent`->v.flags & FL_WATERJUMP) )
	{
		// we are not in water so set basevelocity to 0
		// what happens if we are on a conveoyer?
		VectorCopy(vec_origin, ent->p.basevelocity);

		P_AddGravity (ent);
	}
*/

	VectorCopy (ent->s.origin, old_origin);

//	P_CheckGround (ent);
	
	P_AddGravity (ent);

	//	if we're on the ground and not moving in the x/y plane, then don't run physics
	if (ent->groundEntity == NULL || ent->velocity [0] != 0 || ent->velocity [1] != 0)
	{
		P_BotWalkMove (ent);
		P_BotFriction (ent);

		gi.linkentity (ent);

		P_CheckWaterTransition (ent, old_origin);
	}

	//	run think function
	P_RunThink (ent);
}

///////////////////////////////////////////////////////////////////////////////
//	P_RunEntity
//
//	Nelno:	similar as P_Physics in Quake 1 source
///////////////////////////////////////////////////////////////////////////////

void P_RunEntity (edict_t *ent)
{
	switch (ent->movetype)
	{
		case	MOVETYPE_PUSH:
		case	MOVETYPE_STOP:
				P_Physics_Pusher (ent);
				break;

		case	MOVETYPE_NONE:
				P_Physics_None (ent);
				break;

		case	MOVETYPE_NOCLIP:
				P_Physics_Noclip (ent);
				break;

		case	MOVETYPE_STEP:
				P_Physics_Step (ent);
				break;

		case	MOVETYPE_TOSS:
		case	MOVETYPE_BOUNCE:
		case	MOVETYPE_FLY:
		case	MOVETYPE_FLYMISSILE:
		case	MOVETYPE_BOUNCEMISSILE:
		case	MOVETYPE_FLOAT:
				P_Physics_Toss (ent);
				break;

		case	MOVETYPE_WALK:
				Physics_Walk (ent);
				break;
		
		default:
				gi.error ("P_RunEntity: bad movetype %i", (int)ent->movetype);			
	}
}
